import { type IType, type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClassroomcourseplan {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  ClassRelationTemplateId!: IType<number, bigint>;
  SchoolId!: IType<number, bigint>;
  GradeId!: IType<number, bigint>;
  ClassId!: IType<number, bigint>;
  TeacherId!: IType<number, bigint>;
  SubjectId!: IType<number, bigint>;
  Name?: string;
  ClassRoomCourseId?: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  ExecutionTime!: Date & Opt;
  ExpireTime!: Date & Opt;
}

export const IcrClassroomcourseplanSchema = defineEntity({
  class: IcrClassroomcourseplan,
  comment: '课程计划;',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    ClassRelationTemplateId: p.bigint().name('ClassRelationTemplateId').columnType('bigint').comment('引用的模板Id'),
    SchoolId: p.bigint().name('SchoolId').columnType('bigint').comment('学校Id'),
    GradeId: p.bigint().name('GradeId').columnType('bigint').comment('年级Id'),
    ClassId: p.bigint().name('ClassId').columnType('bigint').comment('班级id'),
    TeacherId: p.bigint().name('TeacherId').columnType('bigint').comment('教师Id'),
    SubjectId: p.bigint().name('SubjectId').columnType('bigint').comment('关联学科'),
    Name: p.string().name('Name').nullable().comment('名课程称'),
    ClassRoomCourseId: p.bigint().name('ClassRoomCourseId').columnType('bigint').nullable().comment('课程id'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    ExecutionTime: p.datetime().name('ExecutionTime').length(3).comment('执行时间').defaultRaw(`2025-12-11 14:18:48.727`),
    ExpireTime: p.datetime().name('ExpireTime').length(3).comment('过期时间').defaultRaw(`0001-01-01 00:00:00.000`),
  },
});
